#pragma once

#include "plugin.h"
#include "sb.h"

#define DEF_STORE(NAME, TYPE, MAX_SIZE) \
    typedef struct NAME {               \
        TYPE data[MAX_SIZE];            \
        size_t count;                   \
    } NAME##_t

#define FOREACH_STORE(VALUE_NAME, STORE) \
    for (typeof(&STORE.data[0]) VALUE_NAME = STORE.data; VALUE_NAME < STORE.data + STORE.count; ++VALUE_NAME)

#define FOREACH_LIST(VALUE_NAME, LIST) \
    for (typeof(LIST) VALUE_NAME = LIST; VALUE_NAME; VALUE_NAME = VALUE_NAME->next_tied)

typedef struct disk_info {
    imsm_super_t* sb;
    imsm_disk_t* disk;
    struct disk_info* next_tied;
    storage_object_t* evms_data;
    u_int8_t index;
} disk_info_t;

DEF_STORE(disk_infos_store, disk_info_t, 1024);

typedef struct container_info {
    imsm_super_t* sb; // owner
    disk_info_t* disks;
    struct volume_info* volumes;
    storage_container_t* evms_data;
    int md_minor;
    u_int8_t active;
} container_info_t;

DEF_STORE(container_infos_store, container_info_t, 256);

typedef struct volume_info {
    imsm_dev_t* dev;
    container_info_t* container;
    struct volume_info* next_tied;
    storage_object_t* evms_data;
    u_int8_t index;
} volume_info_t;

DEF_STORE(volume_infos_store, volume_info_t, 1024);

#undef DEF_STORE
